import { reducerFactory } from 'app/core/redux';
import { reportLoaded, reportsLoaded } from './actions';
import { Report, ReportsState } from '../../types';

const initialState: ReportsState = {
  reports: [] as Report[],
  report: {} as Report,
  hasFetchedList: false,
  hasFetchedSingle: false,
  searchQuery: '',
  reportCount: 0,
};

export const reportsReducers = reducerFactory(initialState)
  .addMapper({
    filter: reportsLoaded,
    mapper: (state, action) => ({
      ...state,
      reports: action.payload,
      reportCount: action.payload.length,
      hasFetchedList: true,
    }),
  })
  .addMapper({
    filter: reportLoaded,
    mapper: (state, action) => ({
      ...state,
      report: action.payload,
      hasFetchedSingle: true,
    }),
  })
  .create();

export default {
  reports: reportsReducers,
};
